#!/bin/bash

Init()
{
    echo "Init"

    DoFileList
}

Destroy()
{
    echo "Destroy"
}

DoFileList()
{
    Widget FileList clear
    
    TARGETFILTER="~Desktop/Piccies/*"

    ls -d $TARGETFILTER >temp
    
    sed -i 's/^/Widget FileList addUniqueItem "/;s/$/"/' temp
    
    chmod u+x temp
    
    cat temp

    . ./temp
    
    rm -f temp
}

FileList()
{
    echo "FileList"
}

ViewButton()
{
    echo "ViewButton"
    
    SELECTEDFOLDER="`Widget FileList selection`"
    
    echo "SELECTEDFOLDER=$SELECTEDFOLDER"
    
    gwenview "$SELECTEDFOLDER" &
}

CameraCardReaderButton()
{
    FILESYSTEMS="`awk '$4~/^sd[a-z]$/ {next} $1=="8" {print $4}' /proc/partitions`"
    DATE="`date +'%Y-%m-%d %H%M%S'`"
    
    CARDPATH="dcim/100sscam/"
    TARGETPATH="~Desktop/Piccies/100sscam $DATE"
    
    echo "FILESYSTEMS=$FILESYSTEMS"
    echo "CARDPATH=$CARDPATH"
    echo "TARGETPATH=$TARGETPATH"
    echo "DATE=$DATE"
    
    mkdir -p mount
    
    for FILESYSTEM in $FILESYSTEMS
    do
        echo "FILESYSTEM=$FILESYSTEM"
        
        sudo mount /dev/$FILESYSTEM mount
        
        ls mount
        
        if [ -e "mount/$CARDPATH/"* ]
        then
            mkdir "$TARGETPATH"
            
            xterm -e cp -vv "mount/$CARDPATH/"* "$TARGETPATH"
            
            DoFileList
            
            gwenview "$TARGETPATH" &
            
            if kdialog -title "Clean up card" --yesno "Would you like to empty the card?"
            then
                sudo rm -vf "mount/$CARDPATH/"*
            fi
            
            kdialog --msgbox "You can remove the card" &
        fi

        sudo umount mount
    done
}
