#!/bin/bash

if [ $# -lt 1 ]
then
	echo "USE: $0 <template name>"
	exit
fi

TEMPLATEFOLDER=/home/graham/Desktop/Projects/VisualBash/CreateProject

TEMPLATENAME=$1
SOURCEFOLDER="`pwd`"
PROJECTNAME="`basename "$SOURCEFOLDER"`"

TARGETFOLDER="$TEMPLATEFOLDER/$TEMPLATENAME"

mkdir -p "$TARGETFOLDER"

cp -d "$SOURCEFOLDER"/* "$TARGETFOLDER/"

if pushd "$TARGETFOLDER" >/dev/null
then
    for FILE in "$PROJECTNAME"*
    do
        EXTENSION="`echo "$FILE" |egrep -o "\.[^.]*$"`"

    	mv $FILE "$TEMPLATENAME"$EXTENSION
    done

	find -type f -exec sed -i 's/'"$PROJECTNAME"'/'"$TEMPLATENAME"'/g' {} \;
	sed -i '/^Exec/cExec=cd '"$TARGETFOLDER"' && ./'"$TEMPLATENAME"'.sh --GUI' "$TEMPLATENAME.desktop"
	sed -i '/^Exec/cExec=cd '"$TARGETFOLDER"' && ./'"$TEMPLATENAME"'.sh --DEBUG' "debug.desktop"
	
	chmod -R a-w .

	popd >/dev/null

	echo "Created template $TEMPLATENAME"
else
	echo "template $TEMPLATENAME NOT created"
fi
