Init()
{
    Widget ProjectFolder setText "$HOME/Desktop"

    echo "$HOME/Desktop added"

    for FOLDER in *
    do
        echo "FOLDER=$FOLDER"
        if [ -n "`ls $FOLDER/*.kmdr 2>/dev/null`" ]
        then
            echo "Adding $FOLDER"
            Widget ProjectList insertItem "$FOLDER" 0
        fi
    done
}

Destroy()
{
    echo "destroy"
}

SetProject()
{
    echo "SetProject"
    
    PROJECTSELECTION="`Widget ProjectList selection`"
    PROJECTNAME="New$PROJECTSELECTION"
    
    echo "PROJECTSELECTION=$PROJECTSELECTION"
    echo "PROJECTNAME=$PROJECTNAME"
    
    Widget ProjectName setText "$PROJECTNAME"
}

# Event Handlers
CreateProject()
{
    PROJECTNAME="`Widget ProjectName text`"
    PROJECTFOLDER="`Widget ProjectFolder text`"
    PROJECTTEMPLATE="`Widget ProjectList selection`"
    
    echo "PROJECTNAME=\"$PROJECTNAME\""
    echo "PROJECTFOLDER=\"$PROJECTFOLDER\""
    echo "PROJECTTEMPLATE=\"$PROJECTTEMPLATE\""
    
    if [ -z "$PROJECTTEMPLATE" ] || [ -z "$PROJECTNAME" ]
    then
        kdialog --msgbox "Please select a project and give it a name"
    else

        TARGETFOLDER="$PROJECTFOLDER/$PROJECTNAME"

        mkdir -p "$TARGETFOLDER"

        cp -d "$PROJECTTEMPLATE"/* "$TARGETFOLDER/"

        if pushd "$TARGETFOLDER"
        then
            for FILE in "$PROJECTTEMPLATE"*
            do
                EXTENSION="`echo "$FILE" |egrep -o "\.[^.]*$"`"

                mv $FILE "$PROJECTNAME"$EXTENSION
            done

            find -type f -exec sed -i 's/'"$PROJECTTEMPLATE"'/'"$PROJECTNAME"'/g' {} \;

            sudo chown -R `id -un`:`id -gn` .
            chmod -R u+w .

            find -type d -name ".svn" -exec rm -rf {} \;

            Widget StatusBar setText "Created project $PROJECTNAME in folder $PROJECTFOLDER"

            kmdr-editor  "$PROJECTNAME.kmdr" &
            nedit "$PROJECTNAME.sh" &

            popd
 
            quit
        else
            Widget StatusBar setText "Project $PROJECTNAME NOT created in folder $PROJECTFOLDER"
        fi
    fi
}
