DIALOGPATH="$1"
DIALOGFILE="$2"
EVENT="$3"
PACKAGE="$4"
DIALOGID="$5"

DIALOGSCRIPT="`basename $DIALOGFILE .kmdr`.sh"

if [ -z "$PACKAGE" ]
then
    OURPARENT=`ps h -o ppid -p $PPID`

    PARENTSPARENT=`ps h -o ppid -p $OURPARENT`
    PARENTSPARENTSPARENT=`ps h -o ppid -p $PARENTSPARENT`
    ISEDITOR=`ps h -o fname -p $PARENTSPARENTSPARENT`
    
    if [ "$ISEDITOR" == "kmdr-edi" ]
    then
        PACKAGE=debug
    else
        PACKAGE=release
    fi
fi

[ -z "$LOG" ] && LOG="output.log"

cd $DIALOGPATH

init()
{
	if [ "$PACKAGE" == "debug" ]
	then
		>$LOG
		xterm +sb -vb -title "Debug output console" -e "tail -f $LOG" &
		LOG_PID=$!
		echo "$LOG_PID" >LOG_PID
	fi

    echo "DIALOGPATH=$DIALOGPATH"
    echo "DIALOGFILE=$DIALOGFILE"
    echo "EVENT=$EVENT"
    echo "PACKAGE=$PACKAGE"
    echo "DIALOGID=$DIALOGID"
    echo "DIALOGSCRIPT=$DIALOGSCRIPT"
    
    Init
}

destroy()
{
 	if [ -e LOG_PID ]
	then
		LOG_PID="`< LOG_PID`"
		rm -f LOG_PID
		kill $LOG_PID
	fi
    
    Destroy
}
    Init

Widget()
{
	if  [ -n "$DIALOGID" ]
	then

		case $# in
			2)
				dcop $DIALOGID KommanderIf "$2" "$1"
			;;
			3)
				dcop $DIALOGID KommanderIf "$2" "$1" "$3"
			;;
			4)
				dcop $DIALOGID KommanderIf "$2" "$1" "$3" "$4"
			;;
			5)
				dcop $DIALOGID KommanderIf "$2" "$1" "$3" "$4" "$5"
			;;
			6)
				dcop $DIALOGID KommanderIf "$2" "$1" "$3" "$4" "$5" "$6"
			;;
		esac
	fi
}

quit()
{
    destroy
    
    dcop $DIALOGID MainApplication-Interface quit
}


. $DIALOGPATH/$DIALOGSCRIPT

$EVENT >>$LOG 2>>$LOG
